VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Buffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' A class type buffer for the winsock Controls
' On slower systems multiple packets could arrive and be seen as a single packet.
' This helps to split the packets and pass one command at a time..
' All data sent must end with VbCrLf
' not to be used for file transfers..
' Buffer works on FIFO method (First in - First out)
' refined buffer to slowly feed back any incomming winsock data. Smoother chats on
' slower systems as the winsock gets time to add on to the buffer while there is
' still data in it..
Private Buffer() As String
Private Sender_IP() As String
Public Event Data(String_Data As String, Remote_IP As String)
Private Buffer_Holder As Frm_Buffer
Private WithEvents Ticker As Timer
Attribute Ticker.VB_VarHelpID = -1
'

Private Sub Class_Initialize()
ReDim Buffer(0)
ReDim Sender_IP(0)
Set Buffer_Holder = New Frm_Buffer
Set Ticker = Buffer_Holder.Timer1
Ticker.Interval = 100
Ticker.Enabled = True
End Sub

Public Sub Add_2_Buffer(Data As String, Remote_IP As String)
Dim Tmp_Buf() As String
Dim Tmp_loop As Long
Dim Tmp_Total As Long
Dim Tmp_Add As Long
Tmp_Buf = Split(Data, vbCrLf, -1, vbTextCompare)
Tmp_Total = UBound(Buffer)
Tmp_Add = UBound(Tmp_Buf)
If Tmp_Add >= 0 Then ' Add the data to the FiFo buffer
    ReDim Preserve Buffer(Tmp_Total + Tmp_Add + 1)
    ReDim Preserve Sender_IP(Tmp_Total + Tmp_Add + 1)
    For Tmp_loop = 0 To Tmp_Add
        Buffer(Tmp_Total + Tmp_loop + 1) = Tmp_Buf(Tmp_loop)
        Sender_IP(Tmp_Total + Tmp_loop + 1) = Remote_IP
    Next
End If
Ticker.Enabled = True ' Start the feed back
End Sub

Public Function Get_Prev() As String
Get_Prev = Buffer(0)
End Function

Private Sub Class_Terminate()
ReDim Buffer(0)
ReDim Sender_IP(0)
Ticker.Enabled = False
Set Ticker = Nothing
Unload Buffer_Holder ' Setting a form to nothing does not unload it ...
Set Buffer_Holder = Nothing
End Sub

Private Sub Ticker_Timer()
Dim Tmp_loop As Long
Dim Tmp_Total As Long
Tmp_Total = UBound(Buffer) - 1
If Tmp_Total <> -1 Then
    For Tmp_loop = 0 To Tmp_Total
        Buffer(Tmp_loop) = Buffer(Tmp_loop + 1)
        Sender_IP(Tmp_loop) = Sender_IP(Tmp_loop + 1)
    Next
    ReDim Preserve Buffer(Tmp_Total)
    If Buffer(0) <> "" Then 'flush blank lines..
        RaiseEvent Data(Buffer(0), Sender_IP(0)) ' on each tick send the next packet of data..
    End If
Else
    Ticker.Enabled = False
End If
End Sub
